<?php
$set['script']     = $_SERVER['PHP_SELF'];
$set['Title']      = "cineteca Attori";
$set['FirstField'] = "onload='document.actorForm.nome.focus()'";
$set['log']        = false;
$set['mySql']      = true;

if($set['log']) error_log("script      : ***** ".$set['script'], 0);
if($set['log']) error_log("bottone     : ".(empty($_POST['submit']) ? '' : $_POST['submit']), 0);

require_once 'cineteca.include';

/* ---------------------------------------------------------------- */

$set['todo'] = "form"; 
$message = "";

if ( empty($_POST) or $_POST['submit'] == "rinuncia" )
{
    inizializzaVariabili();
}
else
{
    leggiPost();

    validaForm();

    if  ( empty($message)
    and   in_array( $set['azione'], 
                    array("cerca", "conferma", "conferma ins", "conferma mod", "conferma elim") ) )
    {
        aggiornaDB($set['azione']);
    }
}
if ( $set['todo'] == "list" ) displayActorList();
else                          displayForm($set['azione']);
die;

/* ---------------------------------------------------------------- */

function inizializzaVariabili()
{
    global $conn, $set, $row;

    if($set['log']) error_log("inizializzaVariabili", 0);

    $set['azione']        = "";

    $row['actor_id']      = "";
    $row['nome']          = "";
    $row['cognome']       = "";
    $row['performer_aka'] = "";
    $row['foto']          = "";
    $row['foto_info']     = "";
    $row['website']       = "";
    $row['career_status'] = "";
    $row['birthday']      = "";
    $row['died']          = "";
    $row['eye_color']     = "";
    $row['height']        = "";
    $row['biografia']     = "";
}

/* ---------------------------------------------------------------- */

function leggiPost()
{
    global $conn, $set, $row;

    $set['azione']        = trim(htmlspecialchars($_POST['submit']));

    if($set['log']) error_log("leggiPost   : ".$set['azione'], 0);

    if ( $set['azione'] == "conferma" )
    {
        $row['actor_id']      = trim(htmlspecialchars($_POST['rowid']));
    }
    else
    {
        $row['actor_id']      = trim(htmlspecialchars($_POST['actor_id']));
        $row['nome']          = trim(htmlspecialchars($_POST['nome']));
        $row['cognome']       = trim(htmlspecialchars($_POST['cognome']));
        $row['performer_aka'] = trim(htmlspecialchars($_POST['performer_aka']));
        $row['foto']          = trim(htmlspecialchars($_POST['foto']));
        $row['foto_info']     = trim(htmlspecialchars($_POST['foto_info']));
        $row['website']       = trim(htmlspecialchars($_POST['website']));
        $row['career_status'] = trim(htmlspecialchars($_POST['career_status']));
        $row['birthday']      = trim(htmlspecialchars($_POST['birthday']));
        $row['died']          = trim(htmlspecialchars($_POST['died']));
        $row['eye_color']     = trim(htmlspecialchars($_POST['eye_color']));
        $row['height']        = trim(htmlspecialchars($_POST['height']));
        $row['biografia']     = trim(htmlspecialchars($_POST['biografia']));
    }
}

/* ---------------------------------------------------------------- */

function validaForm()
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("validaForm  : ".$set['azione'], 0);

    // qui vanno fatti i controlli dei dati inseriti

    if( !in_array( $set['azione'], 
                   array("inserisci", "cerca", "conferma", "modifica", "elimina", "conferma ins", "conferma mod", "conferma elim") ) ) 
    {
        $message = "ERRORE : validaForm, non riconosco l&acute; azione da compiere";
        return;
    }

    if( in_array( $set['azione'], 
                  array("conferma") ) )
    {
        if( empty($row['actor_id']) )
        {
            $set['azione'] = "";
            $message = "ERRORE : non hai fatto nessuna scelta";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("modifica", "elimina", "conferma mod", "conferma elim") ) )
    {
        if( empty($row['actor_id']) )
        {
            $set['azione'] = "";
            $message = "ERRORE : devi indicare l&acute; ID dell&acute; attore";
            return;
        }
        if( empty(aggiornaDB("conta_id")) )
        {
            $set['azione'] = "";
            $message = "ERRORE : non ho trovato nessun elemento con l&acute; ID indicato";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("elimina") ) )
    {
        if( !empty(aggiornaDB("conta_colleg")) )
        {
            inizializzaVariabili();
            $message = "ERRORE : esistono film collegati, l&acute; attore non puo&grave; essere eliminato dal DB";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("inserisci", "conferma ins") ) )
    {
        if( !empty($row['actor_id']) )
        {
            $set['azione'] = "";
            $message = "ERRORE : nella fase di inserimento l&acute; ID non deve essere presente";
            return;
        }
        if( !empty(aggiornaDB("conta_attore")) )
        {
            $set['azione'] = "";
            $message = "ERRORE : stai tentando di inserire un attore che esiste gi&agrave;";
            return;
        }
    }

    if( in_array( $set['azione'], 
                  array("inserisci", "conferma ins", "modifica", "conferma mod") ) )
    {
//      QUI DEVE ESSERE CONTROLLATA LA PRESENZA E CONGRUITA' DEI DATI INSERITI
    }
}

/* ---------------------------------------------------------------- */

function aggiornaDB($azione = "")
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("aggiornaDB  : ".$azione, 0);

    switch ($azione)
    {
        case "conferma ins":
            $sql = "INSERT INTO actor(nome, cognome, performer_aka, foto, foto_info, website, career_status, birthday, died, eye_color, height, biografia) VALUES ("
                 . "  '" . $row['nome']          . "'"
                 . ", '" . $row['cognome']       . "'"
                 . ", '" . $row['performer_aka'] . "'"
                 . ", '" . $row['foto']          . "'"
                 . ", '" . $row['foto_info']     . "'"
                 . ", '" . $row['website']       . "'"
                 . ", '" . $row['career_status'] . "'"
                 . ", '" . $row['birthday']      . "'"
                 . ", '" . $row['died']          . "'"
                 . ", '" . $row['eye_color']     . "'"
                 . ", '" . $row['height']        . "'"
                 . ", '" . $row['biografia']     . "'"
                 . "  )";
            $x = "inserito";
            break;

        case "conferma mod":
            $sql = "UPDATE actor SET"
                 . "  nome='"           . $row['nome']          . "'"
                 . ", cognome='"        . $row['cognome']       . "'"
                 . ", performer_aka='"  . $row['performer_aka'] . "'"
                 . ", foto='"           . $row['foto']          . "'"
                 . ", foto_info='"      . $row['foto_info']     . "'"
                 . ", website='"        . $row['website']       . "'"
                 . ", career_status='"  . $row['career_status'] . "'"
                 . ", birthday='"       . $row['birthday']      . "'"
                 . ", died='"           . $row['died']          . "'"
                 . ", eye_color='"      . $row['eye_color']     . "'"
                 . ", height='"         . $row['height']        . "'"
                 . ", biografia='"      . $row['biografia']     . "'"
                 . "  WHERE actor_id='" . $row['actor_id']      . "'";
            $x = "modificato";
            break;

        case "conferma elim":
            $sql = "DELETE FROM actor"
                 . " WHERE actor_id='" . $row['actor_id']. "'";
            $x = "eliminato";
            break;

        case "cerca":
        case "conferma":
            if( !empty($row['film_id']) )
            {
                $sql = "SELECT actor_id, nome, cognome, performer_aka, foto, foto_info, website, career_status, birthday, died, eye_color, height, biografia"
                     . " FROM actor WHERE actor_id='" . $row['actor_id'] . "'";
            }
            else
            {
                $sql = "SELECT actor_id, nome, cognome, performer_aka, foto, foto_info, website, career_status, birthday, died, eye_color, height, biografia"
                     . " FROM actor WHERE 1=1";
                if ($row['actor_id'])      { $sql.= " and actor_id="             . $row['actor_id']; }
                if ($row['nome'])          { $sql.= " and nome like '%"          . $row['nome']."%'"; }
                if ($row['cognome'])       { $sql.= " and cognome like '%"       . $row['cognome']."%'"; }
                if ($row['performer_aka']) { $sql.= " and performer_aka like '%" . $row['performer_aka']."%'"; }
                if ($row['foto'])          { $sql.= " and foto like '%"          . $row['foto']."%'"; }
                if ($row['foto_info'])     { $sql.= " and foto_info like '%"     . $row['foto_info']."%'"; }
                if ($row['website'])       { $sql.= " and website like '%"       . $row['website']."%'"; }
                if ($row['career_status']) { $sql.= " and career_status like '%" . $row['career_status']."%'"; }
                if ($row['birthday'])      { $sql.= " and birthday like '%"      . $row['birthday']."%'"; }
                if ($row['died'])          { $sql.= " and died like '%"          . $row['died']."%'"; }
                if ($row['eye_color'])     { $sql.= " and eye_color like '%"     . $row['eye_color']."%'"; }
                if ($row['height'])        { $sql.= " and height like '%"        . $row['height']."%'"; }
                if ($row['biografia'])     { $sql.= " and biografia like '%"     . $row['biografia']."%'"; }
                $sql.= " ORDER BY cognome, nome, birthday";
            }
            break;

        case "conta_id":
            $sql = "SELECT count(*) as counter FROM actor WHERE actor_id='" . $row['actor_id'] . "'";
            break;

        case "conta_attore":
            $sql = "SELECT count(*) as counter FROM actor WHERE nome='" . $row['nome'] . "' and cognome='" . $row['cognome'] . "'";
            break;

        case "conta_colleg":
            $sql = "SELECT count(*) as counter FROM film_actor WHERE actor_id=" . $row['actor_id'];
            break;

        default:
            $message = "ERRORE : aggiornaDB, non riconosco l&acute; azione da compiere";
            return;
            break;
    }



    if($set['log']) error_log("sql         : ".$sql, 0);

    $result = $conn->query($sql);
    if ( !$result ) { $message = "ERRORE : aggiornaDB, errore nella query, " . $conn->error; return; }



    switch ($azione)
    {
        case "cerca":
        case "conferma":
            if($set['mySql']) { $dati = $result->fetch_all(MYSQLI_ASSOC);  $result->free(); }
            else              { $dati = $conn->queryS($sql); }

            if( count($dati) == 1 ) { $row = $dati[0]; $set['todo'] = "form"; } else
            if( count($dati) > 1 )  { $row = $dati;    $set['todo'] = "list"; } else
            {
                $message = "ERRORE : aggiornaDB, non ho trovato elementi per la ricerca fatta";
                $set['azione'] = "";
            }
            break;

        case "conta_id":
        case "conta_attore":
        case "conta_colleg":
            if($set['mySql']) { $dati = $result->fetch_assoc();  $result->free(); }
            else              { $dati = $result->fetch(); }

            return $dati['counter'];
            break;

        default:
            $message = "Congratulazioni, ".$row['nome']." ".$row['cognome']." é stato ".$x." nel database.";
            inizializzaVariabili();
            break;
    }
}

/* ---------------------------------------------------------------- */

function displayForm($azione = "")
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("displayForm : ".$azione, 0);
    if($set['log']) error_log("errore      : ".$message, 0);

    // gestisci bottoni
    $readonly1 = " readonly";
    $readonly2 = " readonly";

    switch ($azione)
    {
        case "cerca":
        case "conferma":
            $readonly2 = "";
            $btn = "<input type='submit' name='submit' value='modifica' />"
                 . "<span style='padding-left: 30px;'></span>"
                 . "<input type='submit' name='submit' value='elimina' />";
            break;

        case "inserisci":
            $btn = "<input type='submit' name='submit' value='conferma ins' />";
            break;

        case "modifica":
            $btn = "<input type='submit' name='submit' value='conferma mod' />";
            break;

        case "elimina":
            $btn = "<input type='submit' name='submit' value='conferma elim' />";
            break;

        default:
            $readonly1 = "";
            $readonly2 = "";
            $btn = "<input type='submit' name='submit' value='inserisci' />"
                 . "<span style='padding-left: 30px;'></span>"
                 . "<input type='submit' name='submit' value='cerca' />";
            break;
    }
    $btn .= "<span style='padding-left: 30px;'></span>"
         .  "<input type='submit' name='submit' value='rinuncia' />";


    // valorizza la select "career_status"
    $opt = "";
    $career_status = array( 0 => 'scegli uno stato', 1 => 'Active', 2 => 'Retired', 3 => 'Dead' );  // possible options for career status
    for( $i=0; $i < count($career_status); $i++ )
    {
        $selected = $i == $row['career_status'] ? ' selected' : '';
        $opt .= "<option" . $selected . " value='" . $i . "'>" . $career_status[$i] . "</option>";
    }
?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset='utf-8'>
    <meta http-equiv='X-UA-Compatible' content='IE=edge'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>

    <title><?= $set['Title']; ?></title>
  </head>
  <body <?= $set['FirstField']; ?>>

<div class='form-group'>

  <center><h1><span class='infoblock-pagetype'>cineteca Attori</span></h1></center>

  <form name='actorForm' method='POST' action='<?= $set['script']; ?>'>

    <table id='biographyTable' border='0' cellspacing='0' cellpadding='0' width='100%'>
      <tbody>
        <tr>
          <td class='paramname'>
            <b>actor ID:</b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='actor_id' id='actor_id' size='15' value='<?= $row['actor_id']; ?>'<?= $readonly1; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Nome:</b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='nome' id='nome' size='100' value='<?= $row['nome']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Cognome: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='cognome' id='cognome' size='100' value='<?= $row['cognome']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Performer aka:</b>
          </td>
          <td class='paramvalue'>
            <textarea name='performer_aka' id='performer_aka' rows='5' cols='80'<?= $readonly2; ?>><?= $row['performer_aka']; ?></textarea>
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Foto:</b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='foto' id='foto' size='100' value='<?= $row['foto']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Foto info:</b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='foto_info' id='foto_info' size='100' value='<?= $row['foto_info']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Website: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='website' id='website' size='50' value='<?= $row['website']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Carriera: </b> (<b><font color='red'>selezionare il valore</font></b>)
          </td>
          <td class='paramvalue'>
            <select name='career_status', id='career_status'><?= $opt; ?></select>
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Data di nascita: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='birthday' id='birthday' size='15' value='<?= $row['birthday']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Data decesso: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='died' id='died' size='15' value='<?= $row['died']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Eye color: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='eye_color' id='eye_color' size='50' value='<?= $row['eye_color']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Altezza: </b>
          </td>
          <td class='paramvalue'>
            <input type='text' name='height' id='height' size='50' value='<?= $row['height']; ?>'<?= $readonly2; ?> />
          </td>
        </tr>
        <tr>
          <td class='paramname'>
            <b>Biografia: </b>
          </td>
          <td class='paramvalue'>
            <textarea name='biografia' id='editor1' rows='10' cols='80'<?= $readonly2; ?>><?= $row['biografia']; ?></textarea>
          </td>
        </tr>
        <tr>
          <td class='paramvalue-footer center' colspan='2'>
            <br />

            <?= $btn; ?>

            <br />
            <br />
          </td>
        </tr>
      </tbody>
    </table>
  </form>
  <div class='col-sm-10 col-sm-offset-2'><h2><?= $message; ?></h2></div>
</div>

<script src="https://cdn.ckeditor.com/ckeditor5/18.0.0/classic/ckeditor.js"></script>
<script> CKEDITOR.replace('editor1', { extraPlugins: 'colorbutton,colordialog' });</script>

</body>
</html>
<?php
}

/* ---------------------------------------------------------------- */

function displayActorList()
{
    global $conn, $set, $row, $message;

    if($set['log']) error_log("displayActorList   : ".$set['azione'], 0);
    if($set['log']) error_log("errore             : ".$message, 0);
?>
<!DOCTYPE html>
<html>
  <head>
    <meta charset='utf-8'>
    <meta http-equiv='X-UA-Compatible' content='IE=edge'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>

    <title><?= $set['Title']; ?></title>
  </head>
  <body>

<div class='form-group'>

  <center><h1><span class='infoblock-pagetype'>cineteca scelta Attori</span></h1></center>

  <form name='ActorList' method='POST' action='<?= $set['script']; ?>'>

    <table id='biographyTable' border='0' cellspacing='0' cellpadding='0' width='100%'>
      <thead>
        <tr>
          <td class='paramname'><b>Seleziona</b></td>
          <td class='paramname'><b>actor ID</b></td>
          <td class='paramname'><b>Cognome</b></td>
          <td class='paramname'><b>Nome</b></td>
          <td class='paramname'><b>Data di nascita</b></td>
          <td class='paramname'><b>Foto</b></td>
        </tr>
      </thead>
      <tbody>
<?php for($x=0; $x<count($row); $x++) { ?>
        <tr>
          <td class='paramvalue'><input type='radio' name='rowid' value='<?= $row[$x]['actor_id']; ?>'></td>
          <td class='paramvalue'><?= $row[$x]['actor_id']; ?></td>
          <td class='paramvalue'><?= $row[$x]['cognome']; ?></td>
          <td class='paramvalue'><?= $row[$x]['nome']; ?></td>
          <td class='paramvalue'><?= $row[$x]['birthday']; ?></td>
          <td class='paramvalue'><?= $row[$x]['foto']; ?></td>
        </tr>
<?php } ?>
        <tr>
          <td class='paramvalue-footer center' colspan='2'>
            <br />

            <input type='submit' name='submit' value='conferma' />
            <span style='padding-left: 30px;'></span>
            <input type='submit' name='submit' value='rinuncia' />

            <br />
            <br />
          </td>
        </tr>
      </tbody>
    </table>
  </form>
  <div class='col-sm-10 col-sm-offset-2'><h2><?= $message; ?></h2></div>
</div>
</body>
</html>
<?php
}
?>
